<!DOCTYPE html>
<html class=" wexvufsnn idc0_331" lang="en"><head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
    <meta charset="utf-8">
    <title>UCI Protocol</title>
    <meta name="keywords" content="chess,engine,interface,uci,protocol">
    <meta name="author" content="Rudolf Huber">
    <meta name="author" content="Stefan-Meyer Kahlen">
    <meta name="publisher" content="Shredder Chess">
    <link rel="shortcut icon" href="https://backscattering.de/favicon.ico" type="image/x-icon">
<style>
html, body, ul, li {
  margin: 0;
  padding: 0;
}
html {
  font: 1em/1.45 Helvetica Neue, sans-serif, Droid Sans Fallback;
  background: white;
  color: black;
}

body {
  background: #eee;
}
.main {
  background: white;
}
.inner {
  margin: 0 auto;
  max-width: 60em;
  padding: 2em 2.5em 2em 2.5em;

}

header {
  border: 2px solid black;
  background: lightblue;
  padding: 0 1em;
  margin: 3em 0;
}

ul {
  padding-left: 1.5em;
}
li .anchor {
  left: -4em;
}

h1 {
  font-size: 3em;
}
h2 {
  font-size: 2.4em;
}
h3 {
  font-size: 1.8em;
}
h1, h2, h3, li, p, dt, td {
  position: relative;
}
:target {
  background: yellow;
}
.anchor {
  position: absolute;
  top: 0;
  left: -2.5em;
  width: 2em;
  height: 2em;
  text-align: center;
  text-decoration: none;
  color: inherit;
  opacity: 0.5;
}
.anchor::before {
  content: "§";
}

footer {
  border-top: 1px solid #aaa;
  padding: 1em;
  background: #eee;
}
footer a {
  color: #111;
  text-decoration: none;
}

code, pre {
  font-family: monospace, Droid Sans Fallback, Helvetica Neue, sans-serif;
  background: #eee;
}
pre {
  font-size: 0.8em;
  line-height: 1.5em;
}
code :link, code :visited {
  text-decoration: none;
  color: orangered;
}
var {
  font-style: normal;
}
var::before {
  content: "⟨";
}
var::after {
  content: "⟩";
}
td, th {
  border: none;
}
</style>
  </head>
  <body>
    <div class="main">
      <div class="inner">
        <header>
          <p>
            This is a copy of the <strong>April 2006</strong> version of the UCI standard,
            written by Rudolf Huber and Stefan-Meyer Kahlen,
            <a href="https://www.shredderchess.com/chess-features/uci-universal-chess-interface.html">published by Shredder Chess</a>.
          </p>
          <p>
            Note from Niklas Fiekas: For your convenience, I have added markup to the
            <a href="https://backscattering.de/chess/uci/2006-04.txt">original plain text file</a> (as implied) without
            fixing typos or inconsistencies.
            But please <a href="mailto:niklas.fiekas@backscattering.de">let me know</a> if I have introduced any mistakes.
          </p>
        </header>

        <h1 id="uci">
          Description of the universal chess interface (UCI)
        </h1>

        <p id="os">
          The specification is independent of the operating system. For Windows,
          the engine is a normal exe file, either a console or "real" windows application.
          <a href="#os" class="anchor"></a>
        </p>
        <p id="stdio">
          all communication is done via standard input and output with text commands,
          <a href="#stdio" class="anchor"></a>
        </p>
        <p id="boot">
          The engine should boot and wait for input from the GUI,
          the engine should wait for the <code><a href="#gui-isready">isready</a></code> or <code><a href="#gui-setoption">setoption</a></code> command to set up its internal parameters
          as the boot process should be as quick as possible.
          <a href="#boot" class="anchor"></a>
        </p>
        <p id="responsiveness">
          the engine must always be able to process input from stdin, even while thinking.
          <a href="#responsiveness" class="anchor"></a>
        </p>
        <p id="newline">
          all command strings the engine receives will end with <code>\n</code>,
          also all commands the GUI receives should end with <code>\n</code>,
          <a href="#newline" class="anchor"></a>
        </p>
        <p>
          Note: <code>\n</code> can be 0x0d or 0x0a0d or any combination depending on your OS.
        </p>
        <p>
          If you use Engine and GUI in the same OS this should be no problem if you communicate in text mode,
          but be aware of this when for example running a Linux engine in a Windows GUI.
        </p>
        <p id="whitespace">
          arbitrary white space between tokens is allowed
          <a href="#whitespace" class="anchor"></a>
        </p>

        <p>Example:</p>
        <pre>debug on\n</pre>
        and
        <pre>   debug     on  \n</pre>
        and
        <pre>\t  debug \t  \t\ton\t  \n</pre>
        all set the debug mode of the engine on.

        <p id="forced">
          The engine will always be in forced mode which means it should never start calculating
          or pondering without receiving a <code><a href="#gui-go">go</a></code> command first.
          <a href="#forced" class="anchor"></a>
        </p>
        <p id="position-first">
          Before the engine is asked to search on a position, there will always be a <code><a href="#gui-position">position</a></code> command
          to tell the engine about the current position.
          <a href="#position-first" class="anchor"></a>
        </p>
        <p id="book">
          by default all the opening book handling is done by the GUI,
          but there is an option for the engine to use its own book (<code><a href="#engine-option-ownbook">OwnBook</a></code> option, see below)
          <a href="#book" class="anchor"></a>
        </p>
        <p id="unknown">
          if the engine or the GUI receives an unknown command or token it should just ignore it and try to
          parse the rest of the string in this line.
          <a href="#unknown" class="anchor"></a>
        </p>
        <p>Examples:</p>
        <pre>joho debug on\n</pre>
        should switch the debug mode on given that <code>joho</code> is not defined,
        <pre>debug joho on\n</pre>
        will be undefined however.
        <p id="unexpected">
          if the engine receives a command which is not supposed to come, for example <code><a href="#gui-stop">stop</a></code> when the engine is
          not calculating, it should also just ignore it.
          <a href="#unexpected" class="anchor"></a>
        </p>

        <h2 id="move">
          Move format
          <a href="#move" class="anchor"></a>
        </h2>
        <p id="move-lan">
          The move format is in long algebraic notation.
          <a href="#move-lan" class="anchor"></a>
        </p>
        <p id="move-null">
          A nullmove from the Engine to the GUI should be sent as <code>0000</code>.
          <a href="#move-null" class="anchor"></a>
        </p>
        <p id="move-examples">
          Examples: <code>e2e4</code>, <code>e7e5</code>, <code>e1g1</code> (white short castling), <code>e7e8q</code> (for promotion)
          <a href="#move-examples" class="anchor"></a>
        </p>

        <h2 id="gui">
          GUI to engine
          <a href="#gui" class="anchor"></a>
        </h2>
        <p id="gui-commands">
          These are all the command the engine gets from the interface.
          <a href="#gui-commands" class="anchor"></a>
        </p>

        <h3 id="gui-uci">
          <code>uci</code>
          <a href="#gui-uci" class="anchor"></a>
        </h3>
        <p id="gui-uci-mode">
          tell engine to use the uci (universal chess interface),
          this will be sent once as a first command after program boot
          to tell the engine to switch to uci mode.
          <a href="#gui-uci-mode" class="anchor"></a>
        </p>
        <p id="gui-uci-id">
          After receiving the <code>uci</code> command the engine must identify itself with the <code><a href="#engine-id">id</a></code> command
          and send the <code><a href="#engine-option">option</a></code> commands to tell the GUI which engine settings the engine supports if any.
          <a href="#gui-uci-id" class="anchor"></a>
        </p>
        <p id="gui-uci-uciok">
          After that the engine should send <code><a href="#engine-uciok">uciok</a></code> to acknowledge the uci mode.
          If no <code>uciok</code> is sent within a certain time period, the engine task will be killed by the GUI.
          <a href="#gui-uci-uciok" class="anchor"></a>
        </p>

        <h3 id="gui-debug">
          <code>debug</code> [ <code>on</code> | <code>off</code> ]
          <a href="#gui-debug" class="anchor"></a>
        </h3>
        <p id="gui-debug-mode">
          switch the debug mode of the engine on and off.
          In debug mode the engine should send additional infos to the GUI, e.g. with the <code>info string</code> command,
          to help debugging, e.g. the commands that the engine has received etc.
          <a href="#gui-debug-mode" class="anchor"></a>
        </p>
        <p id="gui-debug-default">
          This mode should be switched off by default and this command can be sent
          any time, also when the engine is thinking.
          <a href="#gui-debug-default" class="anchor"></a>
        </p>

        <h3 id="gui-isready">
          <code>isready</code>
          <a href="#gui-isready" class="anchor"></a>
        </h3>
        <p id="gui-isready-ping">
          this is used to synchronize the engine with the GUI. When the GUI has sent a command or
          multiple commands that can take some time to complete,
          this command can be used to wait for the engine to be ready again or
          to ping the engine to find out if it is still alive.
          E.g. this should be sent after setting the path to the tablebases as this can take some time.
          <a href="#gui-isready-ping" class="anchor"></a>
        </p>
        <p id="gui-isready-command">
          This command is also required once before the engine is asked to do any search
          to wait for the engine to finish initializing.
          <a href="#gui-isready-command" class="anchor"></a>
        </p>
        <p id="gui-isready-readyok">
          This command must always be answered with <code><a href="#engine-readyok">readyok</a></code> and can be sent also when the engine is calculating
          in which case the engine should also immediately answer with <code>readyok</code> without stopping the search.
          <a href="#gui-isready-readyok" class="anchor"></a>
        </p>

        <h3 id="gui-setoption">
          <code>setoption name</code> <var>id</var> [ <code>value</code> <var>x</var> ]
          <a href="#gui-setoption" class="anchor"></a>
        </h3>
        <p id="gui-setoption-command">
          this is sent to the engine when the user wants to change the internal parameters
          of the engine. For the <code><a href="#engine-option-type-button">button</a></code> type no value is needed.
          <a href="#gui-setoption-command" class="anchor"></a>
        </p>
        <p id="gui-setoption-multiple">
          One string will be sent for each parameter and this will only be sent when the engine is waiting.
          The name and value of the option in <var>id</var> should not be case sensitive and can inlude spaces.
          <a href="#gui-setoption-multiple" class="anchor"></a>
        </p>
        <p id="gui-setoption-name">
          The substrings <code>value</code> and <code>name</code> should be avoided in <var>id</var> and <var>x</var> to allow unambiguous parsing,
          for example do not use <var>name</var> = <code>draw value</code>.
          <a href="#gui-setoption-name" class="anchor"></a>
        </p>
        <p id="gui-setoption-example">
          Here are some strings for the example below:
          <a href="#gui-setoption-example" class="anchor"></a>
        </p>
        <pre>setoption name Nullmove value true\n</pre>
        <pre>setoption name Selectivity value 3\n</pre>
        <pre>setoption name Style value Risky\n</pre>
        <pre>setoption name Clear Hash\n</pre>
        <pre>setoption name NalimovPath value c:\chess\tb\4;c:\chess\tb\5\n</pre>

        <h3 id="gui-register">
          <code>register</code>
          <a href="#gui-register" class="anchor"></a>
        </h3>
        <p id="gui-register-command">
          this is the command to try to register an engine or to tell the engine that registration
          will be done later. This command should always be sent if the engine has sent <code>registration error</code>
          at program startup.
          <a href="#gui-register-command" class="anchor"></a>
        </p>
        <p>
          The following tokens are allowed:
        </p>
        <dl>
          <dt id="gui-register-later">
            <code>later</code>
            <a href="#gui-register-later" class="anchor"></a>
          </dt>
          <dd><p>the user doesn't want to register the engine now.</p></dd>
          <dt id="gui-register-name">
            <code>name</code> <var>x</var>
            <a href="#gui-register-name" class="anchor"></a>
          </dt>
          <dd><p>the engine should be registered with the name <var>x</var></p></dd>
          <dt id="gui-register-code">
            <code>code</code> <var>y</var>
            <a href="#gui-register-code" class="anchor"></a>
          </dt>
          <dd><p>the engine should be registered with the code <var>y</var></p></dd>
        </dl>
        <p id="gui-register-example">
          Example:
          <a href="#gui-register-example" class="anchor"></a>
        </p>
        <pre>register later</pre>
        <pre>register name Stefan MK code 4359874324</pre>

        <h3 id="gui-ucinewgame">
          <code>ucinewgame</code>
          <a href="#gui-ucinewgame" class="anchor"></a>
        </h3>
        <p id="gui-ucinewgame-command">
          this is sent to the engine when the next search (started with <code><a href="#gui-position">position</a></code> and <code><a href="#gui-go">go</a></code>) will be from
          a different game. This can be a new game the engine should play or a new game it should analyse but
          also the next position from a testsuite with positions only.
          <a href="#gui-ucinewgame-command" class="anchor"></a>
        </p>
        <p id="gui-ucinewgame-optional">
          If the GUI hasn't sent a <code>ucinewgame</code> before the first <code><a href="#gui-position">position</a></code> command, the engine shouldn't
          expect any further <code>ucinewgame</code> commands as the GUI is probably not supporting the <code>ucinewgame</code> command.
          So the engine should not rely on this command even though all new GUIs should support it.
          <a href="#gui-ucinewgame-optional" class="anchor"></a>
        </p>
        <p id="gui-ucinewgame-isready">
          As the engine's reaction to <code>ucinewgame</code> can take some time the GUI should always send <code><a href="#gui-isready">isready</a></code>
          after <code>ucinewgame</code> to wait for the engine to finish its operation.
          <a href="#gui-ucinewgame-isready" class="anchor"></a>
        </p>

        <h3 id="gui-position">
          <code>position</code> [ <code>fen</code> <var>fenstring</var> | <code>startpos</code> ] <code>moves</code> <var>move<sub>1</sub></var> ... <var>move<sub>i</sub></var>
          <a href="#gui-position" class="anchor"></a>
        </h3>
        <p id="gui-position-command">
          set up the position described in <var>fenstring</var> on the internal board and
          play the moves on the internal chess board.
          <a href="#gui-position-command" class="anchor"></a>
        </p>
        <p id="gui-position-startpos">
          if the game was played from the start position the string <code>startpos</code> will be sent
          <a href="#gui-position-startpos" class="anchor"></a>
        </p>
        <p id="gui-position-ucinewgame">
          Note: no "new" command is needed. However, if this position is from a different game than
          the last position sent to the engine, the GUI should have sent a <code><a href="#gui-ucinewgame">ucinewgame</a></code> inbetween.
          <a href="#gui-position-ucinewgame" class="anchor"></a>
        </p>

        <h3 id="gui-go">
          <code>go</code>
          <a href="#gui-go" class="anchor"></a>
        </h3>
        <p id="gui-go-command">
          start calculating on the current position set up with the <code><a href="#gui-position">position</a></code> command.
          <a href="#gui-go-command" class="anchor"></a>
        </p>
        <p id="gui-go-tokens">
          There are a number of commands that can follow this command, all will be sent in the same string.
          If one command is not sent its value should be interpreted as it would not influence the search.
          <a href="#gui-go-tokens" class="anchor"></a>
        </p>
        <dl>
          <dt id="gui-go-searchmoves">
            <code>searchmoves</code> <var>move<sub>1</sub></var> ... <var>move<sub>i</sub></var>
            <a href="#gui-go-searchmoves" class="anchor"></a>
          </dt>
          <dd>
            <p>restrict search to this moves only</p>
            Example: After <code>position startpos</code> and <code>go infinite searchmoves e2e4 d2d4</code>
            the engine should only search the two moves <code>e2e4</code> and <code>d2d4</code> in the initial position.
          </dd>
          <dt id="gui-go-ponder">
            <code>ponder</code>
            <a href="#gui-go-ponder" class="anchor"></a>
          </dt>
          <dd>
            <p>start searching in pondering mode.</p>
            <p>Do not exit the search in ponder mode, even if it's mate!</p>
            <p>
              This means that the last move sent in in the position string is the ponder move.
              The engine can do what it wants to do, but after a <code><a href="#gui-ponderhit">ponderhit</a></code> command
              it should execute the suggested move to ponder on. This means that the ponder move sent by
              the GUI can be interpreted as a recommendation about which move to ponder. However, if the
              engine decides to ponder on a different move, it should not display any mainlines as they are
              likely to be misinterpreted by the GUI because the GUI expects the engine to ponder
              on the suggested move.
            </p>
          </dd>
          <dt id="gui-go-wtime">
            <code>wtime</code> <var>x</var>
            <a href="#gui-go-wtime" class="anchor"></a>
          </dt>
          <dd>
            <p>white has <var>x</var> msec left on the clock</p>
          </dd>
          <dt id="gui-go-btime">
            <code>btime</code> <var>x</var>
            <a href="#gui-go-btime" class="anchor"></a>
          </dt>
          <dd>
            <p>black has <var>x</var> msec left on the clock</p>
          </dd>
          <dt id="gui-go-winc">
            <code>winc</code> <var>x</var>
            <a href="#gui-go-winc" class="anchor"></a>
          </dt>
          <dd>
            <p>white increment per move in mseconds if <var>x</var> &gt; 0</p>
          </dd>
          <dt id="gui-go-binc">
            <code>binc</code> <var>x</var>
            <a href="#gui-go-binc" class="anchor"></a>
          </dt>
          <dd>
            <p>black increment per move in mseconds if <var>x</var> &gt; 0</p>
          </dd>
          <dt id="gui-go-movestogo">
            <code>movestogo</code> <var>x</var>
            <a href="#gui-go-movestogo" class="anchor"></a>
          </dt>
          <dd>
            <p>there are <var>x</var> moves to the next time control,</p>
            <p>this will only be sent if <var>x</var> &gt; 0,</p>
            <p>if you don't get this and get the <code><a href="#gui-go-wtime">wtime</a></code> and <code><a href="#gui-go-btime">btime</a></code> it's sudden death</p>
          </dd>
          <dt id="gui-go-depth">
            <code>depth</code> <var>x</var>
            <a href="#gui-go-depth" class="anchor"></a>
          </dt>
          <dd>
            <p>search <var>x</var> plies only.</p>
          </dd>
          <dt id="gui-go-nodes">
            <code>nodes</code> <var>x</var>
            <a href="#gui-go-nodes" class="anchor"></a>
          </dt>
          <dd>
            <p>search <var>x</var> nodes only,</p>
          </dd>
          <dt id="gui-go-mate">
            <code>mate</code> <var>x</var>
            <a href="#gui-go-mate" class="anchor"></a>
          </dt>
          <dd>
            <p>search for a mate in <var>x</var> moves</p>
          </dd>
          <dt id="gui-go-movetime">
            <code>movetime</code> <var>x</var>
            <a href="#gui-go-movetime" class="anchor"></a>
          </dt>
          <dd>
            <p>search exactly <var>x</var> mseconds</p>
          </dd>
          <dt id="gui-go-infinite">
            <code>infinite</code>
            <a href="#gui-go-infinite" class="anchor"></a>
          </dt>
          <dd>
            <p>search until the <code><a href="#gui-stop">stop</a></code> command. Do not exit the search without being told so in this mode!</p>
          </dd>
        </dl>

        <h3 id="gui-stop">
          <code>stop</code>
          <a href="#gui-stop" class="anchor"></a>
        </h3>
        <p id="gui-stop-command">
          stop calculating as soon as possible,
          <a href="#gui-stop-command" class="anchor"></a>
        </p>
        <p id="gui-stop-bestmove">
          don't forget the <code><a href="#engine-bestmove">bestmove</a></code> and possibly the <code><a href="#engine-bestmove-ponder">ponder</a></code> token when finishing the search
          <a href="#gui-stop-bestmove" class="anchor"></a>
        </p>

        <h3 id="gui-ponderhit">
          <code>ponderhit</code>
          <a href="#gui-ponderhit" class="anchor"></a>
        </h3>
        <p id="gui-ponderhit-command">
          the user has played the expected move. This will be sent if the engine was told to ponder on the same move
          the user has played. The engine should continue searching but switch from pondering to normal search.
          <a href="#gui-ponderhit-command" class="anchor"></a>
        </p>

        <h3 id="gui-quit">
          <code>quit</code>
          <a href="#gui-quit" class="anchor"></a>
        </h3>
        <p id="gui-quit-command">
          quit the program as soon as possible
          <a href="#gui-quit-command" class="anchor"></a>
        </p>

        <h2 id="engine">
          Engine to GUI
          <a href="#engine" class="anchor"></a>
        </h2>

        <h3 id="engine-id">
          <code>id</code>
          <a href="#engine-id" class="anchor"></a>
        </h3>
        <dl>
          <dt id="engine-id-name">
            <code>name</code> <var>x</var>
            <a href="#engine-id-name" class="anchor"></a>
          </dt>
          <dd>
            <p>
              this must be sent after receiving the <code><a href="#gui-uci">uci</a></code> command to identify the engine,
              e.g. <code>id name Shredder X.Y\n</code>
            </p>
          </dd>
          <dt id="engine-id-author">
            <code>author</code> <var>x</var>
            <a href="#engine-id-author" class="anchor"></a>
          </dt>
          <dd>
            <p>
              this must be sent after receiving the <code><a href="#gui-uci">uci</a></code> command to identify the engine,
              e.g. <code>id author Stefan MK\n</code>
            </p>
          </dd>
        </dl>

        <h3 id="engine-uciok">
          <code>uciok</code>
          <a href="#engine-uciok" class="anchor"></a>
        </h3>
        <p id="engine-uciok-command">
          Must be sent after the <code><a href="#engine-id">id</a></code> and optional options to tell the GUI that the engine
          has sent all infos and is ready in uci mode.
          <a href="#engine-uciok-command" class="anchor"></a>
        </p>

        <h3 id="engine-readyok">
          <code>readyok</code>
          <a href="#engine-readyok" class="anchor"></a>
        </h3>
        <p id="engine-readyok-command">
          This must be sent when the engine has received an <code><a href="#gui-isready">isready</a></code> command and has
          processed all input and is ready to accept new commands now.
          <a href="#engine-readyok-command" class="anchor"></a>
        </p>
        <p id="engine-readyok-isready">
          It is usually sent after a command that can take some time to be able to wait for the engine,
          but it can be used anytime, even when the engine is searching,
          and must always be answered with <code><a href="#gui-isready">isready</a></code>.
          <a href="#engine-readyok-isready" class="anchor"></a>
        </p>

        <h3 id="engine-bestmove">
          <code>bestmove</code> <var>move<sub>1</sub></var> [ <code>ponder</code> <var>move<sub>2</sub></var> ]
          <a href="#engine-bestmove" class="anchor"></a>
        </h3>
        <p id="engine-bestmove-command">
          the engine has stopped searching and found the move <var>move</var> best in this position.
          <a href="#engine-bestmove-command" class="anchor"></a>
        </p>
        <p id="engine-bestmove-ponder">
          the engine can send the move it likes to ponder on. The engine must not start pondering automatically.
          <a href="#engine-bestmove-ponder" class="anchor"></a>
        </p>
        <p id="engine-bestmove-stop">
          this command must always be sent if the engine stops searching, also in pondering mode if there is a
          <code><a href="#gui-stop">stop</a></code> command, so for every <code><a href="#gui-go">go</a></code> command a <code>bestmove</code> command is needed!
          <a href="#engine-bestmove-stop" class="anchor"></a>
        </p>
        <p id="engine-bestmove-info">
          Directly before that the engine should send a final <code><a href="#engine-info">info</a></code> command with the final search information,
          the the GUI has the complete statistics about the last search.
          <a href="#engine-bestmove-info" class="anchor"></a>
        </p>

        <h3 id="engine-copyprotection">
          <code>copyprotection</code>
          <a href="#engine-copyprotection" class="anchor"></a>
        </h3>
        <p id="engine-copyprotection-command">
          this is needed for copyprotected engines. After the <code><a href="#engine-uciok">uciok</a></code> command the engine can tell the GUI,
          that it will check the copy protection now. This is done by <code>copyprotection checking</code>.
          <a href="#engine-copyprotection-command" class="anchor"></a>
        </p>
        <p id="engine-copyprotection-error">
          If the check is ok the engine should send <code>copyprotection ok</code>, otherwise <code>copyprotection error</code>.
          If there is an error the engine should not function properly but should not quit alone.
          If the engine reports <code>copyprotection error</code> the GUI should not use this engine
          and display an error message instead!
          <a href="#engine-copyprotection-error" class="anchor"></a>
        </p>
        <p id="engine-copyprotection-code">
          The code in the engine can look like this
          <a href="#engine-copyprotection-code" class="anchor"></a>
        </p>
        <pre>TellGUI("copyprotection checking\n");
// ... check the copy protection here ...
if(ok)
    TellGUI("copyprotection ok\n");
else
    TellGUI("copyprotection error\n");</pre>

        <h3 id="engine-registration">
          <code>registration</code>
          <a href="#engine-registration" class="anchor"></a>
        </h3>
        <p id="engine-registration-command">
          this is needed for engines that need a username and/or a code to function with all features.
          <a href="#engine-registration-command" class="anchor"></a>
        </p>
        <p id="engine-registration-checking">
          Analog to the <code><a href="#engine-copyprotection">copyprotection</a></code> command the engine can send <code>registration checking</code>
          after the uciok command followed by either <code>registration ok</code> or <code>registration error</code>.
          Also after every attempt to register the engine it should answer with <code>registration checking</code>
          and then either <code>registration ok</code> or <code>registration error</code>.
          <a href="#engine-registration-checking" class="anchor"></a>
        </p>
        <p id="engine-registration-error">
          In contrast to the <code><a href="#engine-copyprotection">copyprotection</a></code> command, the GUI can use the engine after the engine has
          reported an error, but should inform the user that the engine is not properly registered
          and might not use all its features.
          <a href="#engine-registration-error" class="anchor"></a>
        </p>
        <p id="engine-registration-gui">
          In addition the GUI should offer to open a dialog to
          enable registration of the engine. To try to register an engine the GUI can send
          the <code><a href="#gui-register">register</a></code> command.
          The GUI has to always answer with the <code>register</code> command
          if the engine sends <code>registration error</code>
          at engine startup (this can also be done with <code>register later</code>)
          and tell the user somehow that the engine is not registered.
          This way the engine knows that the GUI can deal with the registration procedure and the user
          will be informed that the engine is not properly registered.
          <a href="#engine-registration-gui" class="anchor"></a>
        </p>

        <h3 id="engine-info">
          <code>info</code>
          <a href="#engine-info" class="anchor"></a>
        </h3>
        <p id="engine-info-command">
          the engine wants to send information to the GUI. This should be done whenever one of the info has changed.
          <a href="#engine-info-command" class="anchor"></a>
        </p>
        <p id="engine-info-multiple">
          The engine can send only selected infos or multiple infos with one info command,
          e.g. <code>info currmove e2e4 currmovenumber 1</code> or <code>info depth 12 nodes 123456 nps 100000</code>.
          <a href="#engine-info-multiple" class="anchor"></a>
        </p>
        <p id="engine-info-grouping">
          Also all infos belonging to the pv should be sent together
          e.g. <code>info depth 2 score cp 214 time 1242 nodes 2124 nps 34928 pv e2e4 e7e5 g1f3</code>
          <a href="#engine-info-grouping" class="anchor"></a>
        </p>
        <p id="engine-info-delay">
          I suggest to start sending <code><a href="#engine-info-currmove">currmove</a></code>, <code><a href="#engine-info-currmovenumber">currmovenumber</a></code>, <code><a href="#engine-info-currline">currline</a></code> and <code><a href="#engine-info-refutation">refutation</a></code> only after one second
          to avoid too much traffic.
          <a href="#engine-info-delay" class="anchor"></a>
        </p>
        <p>
          Additional info:
        </p>
        <dl>
          <dt id="engine-info-depth">
            <code>depth</code> <var>x</var>
            <a href="#engine-info-depth" class="anchor"></a>
          </dt>
          <dd>
            <p>search depth in plies</p>
          </dd>

          <dt id="engine-info-seldepth">
            <code>seldepth</code> <var>x</var>
            <a href="#engine-info-seldepth" class="anchor"></a>
          </dt>
          <dd>
            <p>selective search depth in plies,</p>
            <p>if the engine sends <code>seldepth</code> there must also be a <code><a href="#engine-info-depth">depth</a></code> present in the same string.</p>
          </dd>

          <dt id="engine-info-time">
            <code>time</code> <var>x</var>
            <a href="#engine-info-time" class="anchor"></a>
          </dt>
          <dd>
            <p>the time searched in ms, this should be sent together with the <code><a href="#engine-info-pv">pv</a></code>.</p>
          </dd>

          <dt id="engine-info-nodes">
            <code>nodes</code> <var>x</var>
            <a href="#engine-info-nodes" class="anchor"></a>
          </dt>
          <dd>
            <p><var>x</var> nodes searched, the engine should send this info regularly</p>
          </dd>

          <dt id="engine-info-pv">
            <code>pv</code> <var>move<sub>1</sub></var> ... <var>move<sub>i</sub></var>
            <a href="#engine-info-pv" class="anchor"></a>
          </dt>
          <dd>
            <p>the best line found</p>
          </dd>

          <dt id="engine-info-multipv">
            <code>multipv</code> <var>num</var>
            <a href="#engine-info-multipv" class="anchor"></a>
          </dt>
          <dd>
            <p>this for the <a href="#engine-option-multipv">multi pv mode</a>.</p>
            <p>for the best move/pv add <code>multipv 1</code> in the string when you send the pv.</p>
            <p>in <em>k</em>-best mode always send all <em>k</em> variants in <em>k</em> strings together.</p>
          </dd>

          <dt id="engine-info-score">
            <code>score</code>
            <a href="#engine-info-score" class="anchor"></a>
          </dt>
          <dd>
            <dl>
              <dt id="engine-info-score-cp">
                <code>cp</code> <var>x</var>
                <a href="#engine-info-score-cp" class="anchor"></a>
              </dt>
              <dd>
                <p>the score from the engine's point of view in centipawns.</p>
              </dd>
              <dt id="engine-info-score-mate">
                <code>mate</code> <var>y</var>
                <a href="#engine-info-score-mate" class="anchor"></a>
              </dt>
              <dd>
                <p>mate in <var>y</var> moves, not plies.</p>
                <p>If the engine is getting mated use negative values for <var>y</var>.</p>
              </dd>
              <dt id="engine-info-score-lowerbound">
                <code>lowerbound</code>
                <a href="#engine-info-score-lowerbound" class="anchor"></a>
              </dt>
              <dd>
                <p>the score is just a lower bound.</p>
              </dd>
              <dt id="engine-info-score-upperbound">
                <code>upperbound</code>
                <a href="#engine-info-score-upperbound" class="anchor"></a>
              </dt>
              <dd>
                <p>the score is just an upper bound.</p>
              </dd>
            </dl>
          </dd>

          <dt id="engine-info-currmove">
          <code>currmove</code> <var>move</var>
            <a href="#engine-info-currmove" class="anchor"></a>
          </dt>
          <dd>
            <p>currently searching this move</p>
          </dd>

          <dt id="engine-info-currmovenumber">
            <code>currmovenumber</code> <var>x</var>
            <a href="#engine-info-currmovenumber" class="anchor"></a>
          </dt>
          <dd>
            <p>currently searching move number <var>x</var>, for the first move <var>x</var> should be 1 not 0.</p>
          </dd>

          <dt id="engine-info-hashfull">
            <code>hashfull</code> <var>x</var>
            <a href="#engine-info-hashfull" class="anchor"></a>
          </dt>
          <dd>
            <p>the hash is <var>x</var> permill full, the engine should send this info regularly</p>
          </dd>

          <dt id="engine-info-nps">
            <code>nps</code> <var>x</var>
            <a href="#engine-info-nps" class="anchor"></a>
          </dt>
          <dd>
            <p><var>x</var> nodes per second searched, the engine should send this info regularly</p>
          </dd>

          <dt id="engine-info-tbhits">
            <code>tbhits</code>
            <a href="#engine-info-tbhits" class="anchor"></a>
          </dt>
          <dd>
            <p><var>x</var> positions where found in the endgame table bases</p>
          </dd>

          <dt id="engine-info-sbhits">
            <code>sbhits</code>
            <a href="#engine-info-sbhits" class="anchor"></a>
          </dt>
          <dd>
            <p><var>x</var> positions where found in the shredder endgame databases</p>
          </dd>

          <dt id="engine-info-cpuload">
            <code>cpuload</code> <var>x</var>
            <a href="#engine-info-cpuload" class="anchor"></a>
          </dt>
          <dd>
          <p>the cpu usage of the engine is <var>x</var> permill.</p>
          </dd>

          <dt id="engine-info-string">
            <code>string</code> <var>str</var>
            <a href="#engine-info-string" class="anchor"></a>
          </dt>
          <dd>
            <p>any string <var>str</var> which will be displayed be the engine,</p>
            <p>if there is a <code>string</code> command the rest of the line will be interpreted as <var>str</var>.</p>
          </dd>

          <dt id="engine-info-refutation">
            <code>refutation</code> <var>move<sub>1</sub></var> <var>move<sub>2</sub></var> ... <var>move<sub>i</sub></var>
            <a href="#engine-info-refutation" class="anchor"></a>
          </dt>
          <dd>
            <p>
              move <var>move<sub>1</sub></var> is refuted by the line <var>move<sub>2</sub></var> ... <var>move<sub>i</sub></var>, <em>i</em> can be any number ≥ 1.
            </p>
            <p>
              Example: after move <code>d1h5</code> is searched, the engine can send
              <code>info refutation d1h5 g6h5</code>
              if <code>g6h5</code> is the best answer after <code>d1h5</code> or if <code>g6h5</code> refutes the move <code>d1h5</code>.
            </p>
            <p>
              if there is no refutation for d1h5 found, the engine should just send
              <code>info refutation d1h5</code>
            </p>
            <p>
              The engine should only send this if the option <code><a href="#engine-option-uci-showrefutations">UCI_ShowRefutations</a></code> is set to true.
            </p>
          </dd>

          <dt id="engine-info-currline">
            <code>currline</code> <var>cpnunr</var> <var>move<sub>1</sub></var> ... <var>move<sub>i</sub></var>
            <a href="#engine-info-currline" class="anchor"></a>
          </dt>
          <dd>
            <p>
              this is the current line the engine is calculating. <var>cpunr</var> is the number of the cpu if
              the engine is running on more than one cpu. <var>cpunr</var> = 1,2,3....
            </p>
            <p>
              if the engine is just using one cpu, <var>cpunr</var> can be omitted.
            </p>
            <p>
              If <var>cpunr</var> is greater than 1, always send all <em>k</em> lines in <em>k</em> strings together.
            </p>
            <p>
              The engine should only send this if the option <code><a href="#engine-option-uci-showcurrline">UCI_ShowCurrLine</a></code> is set to true.
            </p>
          </dd>
        </dl>

        <h3 id="engine-option">
          <code>option</code>
          <a href="#engine-option" class="anchor"></a>
        </h3>
        <p id="engine-option-command">
          This command tells the GUI which parameters can be changed in the engine.
          <a href="#engine-option-command" class="anchor"></a>
        </p>
        <p id="engine-option-uci">
          This should be sent once at engine startup after the <code><a href="#gui-uci">uci</a></code> and the <code><a href="#engine-id">id</a></code> commands
          if any parameter can be changed in the engine.
          <a href="#engine-option-uci" class="anchor"></a>
        </p>
        <p id="engine-option-gui">
          The GUI should parse this and build a dialog for the user to change the settings.
          Note that not every option needs to appear in this dialog as some options like
          <code><a href="#engine-option-ponder">Ponder</a></code>, <code><a href="#engine-option-uci-analysemode">UCI_AnalyseMode</a></code>, etc. are better handled elsewhere or are set automatically.
          <a href="#engine-option-gui" class="anchor"></a>
        </p>
        <p id="engine-option-setoption">
          If the user wants to change some settings, the GUI will send a <code><a href="#gui-setoption">setoption</a></code> command to the engine.
          Note that the GUI need not send the <code>setoption</code> command when starting the engine for every option if
          it doesn't want to change the default value.
          <a href="#engine-option-setoption" class="anchor"></a>
        </p>
        <p id="engine-option-syntax">
          For all allowed combinations see the examples below,
          as some combinations of this tokens don't make sense.
          One string will be sent for each parameter.
          <a href="#engine-option-syntax" class="anchor"></a>
        </p>
        <dl>
          <dt id="engine-option-name">
            <code>name</code> <var>id</var>
            <a href="#engine-option-name" class="anchor"></a>
          </dt>
          <dd>
            <p id="engine-option-name-id">
              The option has the name <var>id</var>.
              <a href="#engine-option-name-id" class="anchor"></a>
            </p>
            <p id="engine-option-name-prefix">
              Certain options have a fixed value for <var>id</var>, which means that the semantics of this option is fixed.
              Usually those options should not be displayed in the normal engine options window of the GUI but
              get a special treatment. <a href="#engine-option-ponder">"Pondering"</a> for example should be set automatically when pondering is
              enabled or disabled in the GUI options. The same for <code><a href="#engine-option-uci-analysemode">UCI_AnalyseMode</a></code> which should also be set
              automatically by the GUI. All those certain options have the prefix <code>UCI_</code> except for the
              first 6 options below. If the GUI gets an unknown Option with the prefix <code>UCI_</code>, it should just
              ignore it and not display it in the engine's options dialog.
              <a href="#engine-option-name-prefix" class="anchor"></a>
            </p>
            <dl>
              <dt id="engine-option-hash">
                <var>id</var> = <code>Hash</code>, type is <code>spin</code>
                <a href="#engine-option-hash" class="anchor"></a>
              </dt>
              <dd>
                <p>
                  the value in MB for memory for hash tables can be changed,
                </p>
                <p>
                  this should be answered with the first <a href="#gui-setoption">"setoptions"</a> command at program boot
                  if the engine has sent the appropriate <code>option name Hash</code> command,
                  which should be supported by all engines!
                  So the engine should use a very small hash first as default.
                </p>
              </dd>
              <dt id="engine-option-nalimovpath">
                <var>id</var> = <code>NalimovPath</code>, type <code>string</code>
                <a href="#engine-option-nalimovpath" class="anchor"></a>
              </dt>
              <dd>
                <p>
                  this is the path on the hard disk to the Nalimov compressed format.
                </p>
                <p>
                  Multiple directories can be concatenated with <code>;</code>
                </p>
              </dd>
              <dt id="engine-option-nalimovcache">
                <var>id</var> = <code>NalimovCache</code>, type <code>spin</code>
                <a href="#engine-option-nalimovcache" class="anchor"></a>
              </dt>
              <dd>
                <p>
                  this is the size in MB for the cache for the nalimov table bases
                </p>
                <p>
                  These last two options should also be present in the initial options exchange dialog
                  when the engine is booted if the engine supports it
                </p>
              </dd>
              <dt id="engine-option-ponder">
                <var>id</var> = <code>Ponder</code>, type <code>check</code>
                <a href="#engine-option-ponder" class="anchor"></a>
              </dt>
              <dd>
                <p>
                  this means that the engine is able to ponder.
                  The GUI will send this whenever pondering is possible or not.
                </p>
                <p>
                  Note: The engine should not start pondering on its own if this is enabled, this option is only
                  needed because the engine might change its time management algorithm when pondering is allowed.
                </p>
              </dd>
              <dt id="engine-option-ownbook">
                <var>id</var> = <code>OwnBook</code>, type <code>check</code>
                <a href="#engine-option-ownbook" class="anchor"></a>
              </dt>
              <dd>
                <p>
                  this means that the engine has its own book which is accessed by the engine itself.
                  if this is set, the engine takes care of the opening book and the GUI will never
                  execute a move out of its book for the engine. If this is set to false by the GUI,
                  the engine should not access its own book.
                </p>
              </dd>
              <dt id="engine-option-multipv">
                <var>id</var> = <code>MultiPV</code>, type <code>spin</code>
                <a href="#engine-option-multipv" class="anchor"></a>
              </dt>
              <dd>
                <p>
                  the engine supports multi best line or <em>k</em>-best mode. the default value is 1
                </p>
              </dd>
              <dt id="engine-option-uci-showcurrline">
                <var>id</var> = <code>UCI_ShowCurrLine</code>, type <code>check</code>, should be false by default,
                <a href="#engine-option-uci-showcurrline" class="anchor"></a>
              </dt>
              <dd>
                <p>
                  the engine can show the current line it is calculating. see <code><a href="#engine-info-currline">info currline</a></code> above.
                </p>
              </dd>
              <dt id="engine-option-uci-showrefutations">
                <var>id</var> = <code>UCI_ShowRefutations</code>, type <code>check</code>, should be false by default,
                <a href="#engine-option-uci-showrefutations" class="anchor"></a>
              </dt>
              <dd>
                <p>
                  the engine can show a move and its refutation in a line. see <a href="#engine-info-refutation">"info refutations"</a> above.
                </p>
              </dd>
              <dt id="engine-option-uci-limitstrength">
                <var>id</var> = <code>UCI_LimitStrength</code>, type <code>check</code>, should be false by default,
                <a href="#engine-option-uci-limitstrength" class="anchor"></a>
              </dt>
              <dd>
                <p>
                  The engine is able to limit its strength to a specific Elo number,
                </p>
                <p>
                  This should always be implemented together with <code><a href="#engine-option-uci-elo">UCI_Elo</a></code>.
                </p>
              </dd>
              <dt id="engine-option-uci-elo">
                <var>id</var> = <code>UCI_Elo</code>, type <code>spin</code>
                <a href="#engine-option-uci-elo" class="anchor"></a>
              </dt>
              <dd>
                <p>
                  The engine can limit its strength in Elo within this interval.
                </p>
                <p>
                  If <code><a href="#engine-option-uci-limitstrength">UCI_LimitStrength</a></code> is set to false, this value should be ignored. If <code>UCI_LimitStrength</code> is set to true, the engine should play with this specific strength. This should always be implemented together with <code>UCI_LimitStrength</code>.
                </p>
              </dd>
              <dt id="engine-option-uci-analysemode">
                <var>id</var> = <code>UCI_AnalyseMode</code>, type <code>check</code>
                <a href="#engine-option-uci-analysemode" class="anchor"></a>
              </dt>
              <dd>
                <p>
                  The engine wants to behave differently when analysing or playing a game.
                  For example when playing it can use some kind of learning.
                  This is set to false if the engine is playing a game, otherwise it is true.
                </p>
              </dd>
              <dt id="engine-option-uci-opponent">
                <var>id</var> = <code>UCI_Opponent</code>, type <code>string</code>
                <a href="#engine-option-uci-opponent" class="anchor"></a>
              </dt>
              <dd>
                <p>
                  With this command the GUI can send the name, title, elo and if the engine is playing a human
                  or computer to the engine.
                </p>
                <p>
                  The format of the string has to be [ <code>GM</code> | <code>IM</code> | <code>FM</code> | <code>WGM</code> | <code>WIM</code> | <code>none</code> ] [ <var>elo</var> | <code>none</code> ] [ <code>computer</code> | <code>human</code> ] <var>name</var>
                </p>
                <p>Examples:</p>
                <pre>setoption name UCI_Opponent value GM 2800 human Gary Kasparov</pre>
                <pre>setoption name UCI_Opponent value none none computer Shredder</pre>
              </dd>
              <dt id="engine-option-uci-engineabout">
                <var>id</var> = <code>UCI_EngineAbout</code>, type <code>string</code>
                <a href="#engine-option-uci-engineabout" class="anchor"></a>
              </dt>
              <dd>
                <p>
                  With this command, the engine tells the GUI information about itself, for example a license text,
                </p>
                <p>
                  usually it doesn't make sense that the GUI changes this text with the setoption command.
                </p>
                <p>
                  Example: <code>option name UCI_EngineAbout type string default Shredder by Stefan Meyer-Kahlen, see www.shredderchess.com</code>
                </p>
              </dd>
              <dt id="engine-option-uci-shredderbasespath">
                <var>id</var> = <code>UCI_ShredderbasesPath</code>, type <code>string</code>
                <a href="#engine-option-uci-shredderbasespath" class="anchor"></a>
              </dt>
              <dd>
                <p>
                  this is either the path to the folder on the hard disk containing the Shredder endgame databases or
                  the path and filename of one Shredder endgame datbase.
                </p>
              </dd>
              <dt id="engine-option-uci-setpositionvalue">
                <var>id</var> = <code>UCI_SetPositionValue</code>, type <code>string</code>
                <a href="#engine-option-uci-setpositionvalue" class="anchor"></a>
              </dt>
              <dd>
                <p>
                  the GUI can send this to the engine to tell the engine to use a certain value in centipawns from white's
                  point of view if evaluating this specifix position.
                </p>
                <p>
                  The string can have the formats:
                  <var>value</var> <code>+</code> <var>fen</var> | <code>clear</code> + <var>fen</var> | <code>clearall</code>
                </p>
              </dd>
            </dl>
          </dd>

          <dt id="engine-option-type">
            <code>type</code> <var>t</var>
            <a href="#engine-option-type" class="anchor"></a>
          </dt>
          <dd>
            <p id="engine-option-type-t">
              The option has type <var>t</var>.
              There are 5 different types of options the engine can send
              <a href="#engine-option-type-t" class="anchor"></a>
            </p>
            <dl>
              <dt id="engine-option-type-check">
                <code>check</code>
                <a href="#engine-option-type-check" class="anchor"></a>
              </dt>
              <dd>
                <p>a checkbox that can either be true or false</p>
              </dd>
              <dt id="engine-option-type-spin">
                <code>spin</code>
                <a href="#engine-option-type-spin" class="anchor"></a>
              </dt>
              <dd>
                <p>a spin wheel that can be an integer in a certain range</p>
              </dd>
              <dt id="engine-option-type-combo">
                <code>combo</code>
                <a href="#engine-option-type-combo" class="anchor"></a>
              </dt>
              <dd>
                <p>a combo box that can have different predefined strings as a value</p>
              </dd>
              <dt id="engine-option-type-button">
                <code>button</code>
                <a href="#engine-option-type-button" class="anchor"></a>
              </dt>
              <dd>
                <p>a button that can be pressed to send a command to the engine</p>
              </dd>
              <dt id="engine-option-type-string">
                <code>string</code>
                <a href="#engine-option-type-string" class="anchor"></a>
              </dt>
              <dd>
                <p>a text field that has a string as a value</p>
                <p>an empty string has the value <code>&lt;empty&gt;</code>
              </p></dd>
            </dl>
          </dd>

          <dt id="engine-option-default">
            <code>default</code> <var>x</var>
            <a href="#engine-option-default" class="anchor"></a>
          </dt>
          <dd>
            <p>the default value of this parameter is <var>x</var>
          </p></dd>

          <dt id="engine-option-min">
            <code>min</code> <var>x</var>
            <a href="#engine-option-min" class="anchor"></a>
          </dt>
          <dd>
            <p>the minimum value of this parameter is <var>x</var>
          </p></dd>

          <dt id="engine-option-max">
            <code>max</code> <var>x</var>
            <a href="#engine-option-max" class="anchor"></a>
          </dt>
          <dd>
            <p>the maximum value of this parameter is <var>x</var>
          </p></dd>

          <dt id="engine-option-var">
            <code>var</code> <var>x</var>
            <a href="#engine-option-var" class="anchor"></a>
          </dt>
          <dd>
            <p>a predefined value of this parameter is <var>x</var>
          </p></dd>
        </dl>

        <p id="engine-option-examples">
          Examples:
          Here are 5 strings for each of the 5 possible types of options
          <a href="#engine-option-examples" class="anchor"></a>
        </p>
        <pre>option name Nullmove type check default true\n</pre>
        <pre>option name Selectivity type spin default 2 min 0 max 4\n</pre>
        <pre>option name Style type combo default Normal var Solid var Normal var Risky\n</pre>
        <pre>option name NalimovPath type string default c:\\n</pre>
        <pre>option name Clear Hash type button\n</pre>

        <h2 id="examples">
          Examples
          <a href="#examples" class="anchor"></a>
        </h2>
        <table>
          <thead>
            <tr>
              <th>GUI</th>
              <th>engine</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <td colspan="2" id="examples-uci">
                tell the engine to switch to UCI mode
                <a href="#examples-uci" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td><pre>uci</pre></td>
              <td></td>
            </tr>
            <tr>
              <td colspan="2" id="examples-identify">
                engine identify
                <a href="#examples-identify" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td></td>
              <td><pre>id name Shredder
id author Stefan MK</pre></td>
            </tr>
            <tr>
              <td colspan="2" id="examples-options">
                engine sends the options it can change
                <br>the engine can change the hash size from 1 to 128 MB
                <a href="#examples-options" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td></td>
              <td><pre>option name Hash type spin default 1 min 1 max 128</pre></td>
            </tr>
            <tr>
              <td colspan="2" id="examples-nalimov">
                the engine supports Nalimov endgame tablebases
                <a href="#examples-nalimov" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td></td>
              <td><pre>option name NalimovPath type string default &lt;empty&gt;
option name NalimovCache type spin default 1 min 1 max 32</pre></td>
            </tr>
            <tr>
              <td colspan="2" id="examples-style">
                the engine can switch off Nullmove and set the playing style
                <a href="#examples-style" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td></td>
              <td><pre>option name Nullmove type check default true
option name Style type combo default Normal var Solid var Normal var Risky</pre></td>
            </tr>
            <tr>
              <td colspan="2" id="examples-ready">
                the engine has sent all parameters and is ready
                <a href="#examples-ready" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td></td>
              <td><pre>uciok</pre></td>
            </tr>
            <tr>
              <td colspan="2" id="examples-note">
                Note: here the GUI can already send a <code><a href="#gui-quit">quit</a></code>
 command if it just wants to find out details about the engine, so the 
engine should not initialize its internal parameters before here.
                <br>now the GUI sets some values in the engine
                <br>set hash to 32 MB
                <a href="#examples-note" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td><pre>setoption name Hash value 32</pre></td>
              <td></td>
            </tr>
            <tr>
              <td colspan="2" id="examples-tbs">
                init tbs
                <a href="#examples-tbs" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td><pre>setoption name NalimovCache value 1
setoption name NalimovPath value d:\tb;c\tb</pre></td>
              <td></td>
            </tr>
            <tr>
              <td colspan="2" id="examples-wait">
                waiting for the engine to finish initializing
                <br>this command and the answer is required here!
                <a href="#examples-wait" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td><pre>isready</pre></td>
              <td></td>
            </tr>
            <tr>
              <td colspan="2" id="examples-done">
                engine has finished setting up the internal values
                <a href="#examples-done" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td></td>
              <td><pre>readyok</pre></td>
            </tr>
            <tr>
              <td colspan="2" id="examples-ready-to-go">
                now we are ready to go
                <a href="#examples-ready-to-go" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td colspan="2" id="examples-ucinewgame">
                if the GUI is supporting it, tell the engine that is is
                searching on a game that it hasn't searched on before
                <a href="#examples-ucinewgame" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td><pre>ucinewgame</pre></td>
              <td></td>
            </tr>
            <tr>
              <td colspan="2" id="examples-analysemode">
                if the engine supports the <code><a href="#engine-option-uci-analysemode">UCI_AnalyseMode</a></code> option and the next search is supposed to
                be an analysis, the GUI should set <code>UCI_AnalyseMode</code> to true if it is currently
                set to false with this engine
                <a href="#examples-analysemode" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td><pre>setoption name UCI_AnalyseMode value true</pre>
              </td><td></td>
            </tr>
            <tr>
              <td colspan="2" id="examples-go">
                tell the engine to search infinite from the start position after 1.e4 e5
                <a href="#examples-go" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td><pre>position startpos moves e2e4 e7e5
go infinite</pre></td>
              <td></td>
            </tr>
            <tr>
              <td colspan="2" id="examples-info">
                the engine starts sending infos about the search to the GUI
                (only some examples are given)
                <a href="#examples-info" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td></td>
              <td><pre>info depth 1 seldepth 0
info score cp 13  depth 1 nodes 13 time 15 pv f1b5
info depth 2 seldepth 2
info nps 15937
info score cp 14  depth 2 nodes 255 time 15 pv f1c4 f8c5
info depth 2 seldepth 7 nodes 255
info depth 3 seldepth 7
info nps 26437
info score cp 20  depth 3 nodes 423 time 15 pv f1c4 g8f6 b1c3
info nps 41562</pre>
....
              </td>
            </tr>
            <tr>
              <td colspan="2" id="examples-stop">
                here the user has seen enough and asks to stop the searching
                <a href="#examples-stop" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td><pre>stop</pre></td>
              <td></td>
            </tr>
            <tr>
              <td colspan="2" id="examples-bestmove">
                the engine has finished searching and is sending the <code><a href="#engine-bestmove">bestmove</a></code> command
                which is needed for every <code><a href="#gui-go">go</a></code> command sent to tell the GUI
                that the engine is ready again
                <a href="#examples-bestmove" class="anchor"></a>
              </td>
            </tr>
            <tr>
              <td></td>
              <td><pre>bestmove g1f3 ponder d8f6</pre></td>
            </tr>
          </tbody>
        </table>

        <h2 id="chess960">
          Chess960
          <a href="#chess960" class="anchor"></a>
        </h2>
        <p id="chess960-extension">
          UCI could easily be extended to support Chess960 (also known as Fischer Random Chess).
          <a href="#chess960-extension" class="anchor"></a>
        </p>
        <p id="chess960-option">
          The engine has to tell the GUI that it is capable of playing Chess960 and the GUI has to tell
          the engine that is should play according to the Chess960 rules.
          This is done by the special engine option <code>UCI_Chess960</code>. If the engine knows about Chess960
          it should send the command <code>option name UCI_Chess960 type check default false</code>
          to the GUI at program startup.
          Whenever a Chess960 game is played, the GUI should set this engine option to <code>true</code>.
          <a href="#chess960-option" class="anchor"></a>
        </p>
        <p id="chess960-castling">
          Castling is different in Chess960 and the white king move when castling short is not always <code>e1g1</code>.
          A king move could both be the castling king move or just a normal king move.
          This is why castling moves are sent in the form king "takes" his own rook.
          Example: <code>e1h1</code> for the white short castle move in the normal chess start position.
          <a href="#chess960-castling" class="anchor"></a>
        </p>
        <p id="chess960-fen">
          In EPD and FEN position strings specifying the castle rights with w and q is not enough as
          there could be more than one rook on the right or left side of the king.
          This is why the castle rights are specified with the letter of the castle rook's line.
          Upper case letters for white's and lower case letters for black's castling rights.
          <a href="#chess960-fen" class="anchor"></a>
        </p>
        <p>Example: The normal chess position would be:</p>
        <pre>rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w AHah -</pre>
      </div>

      <footer>
        <a href="https://backscattering.de/">« backscattering.de</a>
      </footer>
    </div>
  

</body></html>